package reliable_client;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.nio.ByteBuffer;
import java.util.ArrayList;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author persia
 */
public class Reliable_Receive_Thread implements Runnable{
    DatagramSocket DS_Receiver;
    ArrayList<DatagramPacket> recevier_buffer;
    SendFile_UDP sf;
    InetAddress destIP;
    int nOfPacket=0;
    public Reliable_Receive_Thread(DatagramSocket dg) {
        this.DS_Receiver=dg;
        sf=new SendFile_UDP(dg);
        
    }
    public Reliable_Receive_Thread(DatagramSocket dg, DatagramSocket dout, InetAddress destIP, int n) {
        this.DS_Receiver=dg;
        sf=new SendFile_UDP(dout);
        this.destIP=destIP;
        this.nOfPacket=n;
    }
    
    
    @Override
    public void run()
    {
        
        byte[] buf=new byte[PublicStaticVar.chunkSize+PublicStaticVar.Headerbytes];
        DatagramPacket packet=new DatagramPacket(buf, buf.length);
        System.out.println("receiver open");
        int packetCounter=0;
        int experimentNo=0;
        try
        {
           while(true)
           { 
                
                DS_Receiver.receive(packet);
		packetCounter++;
                if(packet.getLength()<50)//control packet
                { //print info about the previous experiment
                    System.out.println("Closing java program");
                    System.exit(0);
                }
                if(packet.getLength()<100)//control packet
                { //print info about the previous experiment
                    System.out.println("Exp "+experimentNo+ "TotalRBytes "+(packetCounter*PublicStaticVar.chunkSize));
                }
                //sf.SendNotification(destIP);
                sf.SendDummyPacket(destIP, nOfPacket);
           }
           
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
    }
    public void decodeData(byte[] packetBuf)
    {
        try
        {
            Checksum ck=new Checksum();
            byte[] data=new byte[PublicStaticVar.chunkSize];
            byte[] destByte=new byte[4];
            byte[] srcByte=new byte[4];
            byte[] seq=new byte[4];
            byte[] checksum=new byte[2];
            System.arraycopy(packetBuf, 0, srcByte, 0, srcByte.length);//copy source copy 32 bits
            System.arraycopy(packetBuf, 4, destByte, 0, destByte.length);//copy dest copy 32 bits
            System.arraycopy(packetBuf, 8, seq, 0, seq.length);//copy sequence numbers copy 32 bits           
            System.arraycopy(packetBuf, 12, checksum, 0, checksum.length);//copy cheksum
            System.arraycopy(packetBuf, 14, data, 0, data.length);
            System.out.println(InetAddress.getByAddress(srcByte).getHostName()
            +" "+InetAddress.getByAddress(destByte).getHostName()
            +" "+ByteBuffer.wrap(seq).getInt());
            if(ByteBuffer.wrap(seq).getInt()==1)
            {
                PublicStaticVar.start_time=System.currentTimeMillis();
            }
            if(ByteBuffer.wrap(seq).getInt()==401)
            {
                PublicStaticVar.end_time=System.currentTimeMillis();
                System.out.println("time elapsed:" + (PublicStaticVar.end_time-PublicStaticVar.start_time));
            }
            
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
    }
    
}
