#include <linux/module.h>

#include <linux/moduleparam.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/stat.h>
//#include "persia_param.h"
MODULE_AUTHOR("Persia");
static int persiaCWMIN = 15;
static int persiaCWMAX = 1023;
extern int cwmin_persia;
extern int cwmax_persia;
module_param(persiaCWMIN, int, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
module_param(persiaCWMAX, int, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
static int __init persia_module_init(void)
{
	cwmin_persia=persiaCWMIN;
	cwmax_persia=persiaCWMAX;
	printk ("New CWmin is %d CWmax %d \n",cwmin_persia,cwmax_persia);
        return 0;
}

static void __exit persia_module_exit(void)
{
	printk ("Unloading cwmin module.\n");
        return;
}

module_init(persia_module_init);
module_exit(persia_module_exit);

MODULE_LICENSE("GPL");
