/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package reliable_client;

import java.nio.ByteBuffer;

/**
 *
 * @author persia
 */
public class Checksum {
    public boolean match(byte[] buf, byte[] checksum)
    {
        //calculate checksum of buf
        // then see if it matches with checksum 
        try
        {
            int length = buf.length;
            int i = 0;

            int sum = 0;
            long data;

            // Handle all pairs
            while (length > 1) 
            {

                data = (((buf[i] << 8) & 0xFF00) | ((buf[i + 1]) & 0xFF));
                sum += data;
                // 1's complement carry bit correction in 16-bits (detecting sign extension)
                if ((sum & 0xFFFF0000) > 0) 
                {
                  sum = sum & 0xFFFF;
                  sum += 1;
                }

                i += 2;
                length -= 2;
            }


            if (length > 0) 
            {

              sum += (buf[i] << 8 & 0xFF00);
              // 1's complement carry bit correction in 16-bits (detecting sign extension)
              if ((sum & 0xFFFF0000) > 0) 
              {
                sum = sum & 0xFFFF;
                sum += 1;
              }
            }

            // Final 1's complement value correction to 16-bits
            int ck=(checksum[0]<<8)&(0xFF00)|(checksum[1]&0xFF);
            System.out.println(Integer.toBinaryString(ck+sum));
            sum = ~sum;
            sum = sum & 0xFFFF;
            
            
            //System.out.println(Integer.toBinaryString(ck)+"=?"+Integer.toBinaryString(sum));
            if(sum==ck)
               return true;
            else
               return false;
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
        return false;
    }
    public byte[] getvalue(byte[] buf)
    {
        try
        {
            int length = buf.length;
            int i = 0;

            int sum = 0;
            long data;

            // Handle all pairs
            while (length > 1) 
            {

                data = (((buf[i] << 8) & 0xFF00) | ((buf[i + 1]) & 0xFF));
                sum += data;
                // 1's complement carry bit correction in 16-bits (detecting sign extension)
                if ((sum & 0xFFFF0000) > 0) 
                {
                  sum = sum & 0xFFFF;
                  sum += 1;
                }

                i += 2;
                length -= 2;
            }


            if (length > 0) 
            {
                
              sum += (buf[i] << 8 & 0xFF00);
              // 1's complement carry bit correction in 16-bits (detecting sign extension)
              if ((sum & 0xFFFF0000) > 0) 
              {
                sum = sum & 0xFFFF;
                sum += 1;
              }
            }

            // Final 1's complement value correction to 16-bits
            sum = ~sum;
            sum = sum & 0xFFFF;
            byte[] checksum=new byte[] {
            (byte)(sum >> 8),
            (byte)sum};
            return checksum;
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
        return null;
    }
    
}
